-module(greedy).
-include("../include/tsp.hrl").
-export([solve/1]).

solve(Problem) ->
%	tour:create_tour(Problem#problem.cities, Problem).
%
%hest(Problem) ->
	Cities = [{C, Problem} || C <- Problem#problem.cities],
	Tours = lists:map(fun create_greedy_solution/1, Cities),
	{_, BestTour} = lists:min([{Length, Tour} || #tour{length=Length} = Tour <- Tours]),
	BestTour.

create_greedy_solution({City, Problem}) ->
	Pending = Problem#problem.cities -- [City],
	create_greedy_solution([City], Pending, Problem).
create_greedy_solution(Cities, [], Problem) ->
	% Create a tour of the found cities
	tour:create_tour(Cities, Problem);
create_greedy_solution(Cities, Pending, #problem{distances = D} = Problem) ->
	{ThisId, _} = hd(Cities),
	% Next city should be the one closest to the current city
	{_, Next} = lists:min(
		[{dict:fetch(tour:order_pair({ThisId, OtherId}), D),
		Other} || {OtherId, _} = Other <- Pending]),
	create_greedy_solution([Next|Cities], Pending -- [Next], Problem).
