-module(pq).
-include("../include/tsp.hrl").
-export([push/2,take/1,take_usable/2,empty/0,is_empty/1]).

empty() ->
	gb_trees:empty().

is_empty(Q) ->
	gb_trees:is_empty(Q).

push(#tour{lower_bound = LB} = Tour, Q) ->
	gb_trees:insert({LB, now()}, Tour, Q).

take(Q) ->
	gb_trees:take_smallest(Q).

take_usable(_BestLength, {0, nil}) ->
	% If pq is empty
	empty;
take_usable(BestLength, Q) ->
	{_, Candidate, Q1} = take(Q),
	case Candidate#tour.lower_bound < BestLength of
		true -> {Candidate, Q1};
		false -> take_usable(BestLength, Q1)
	end.
